/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef DPC_IMPL_TYPE_ADJACENTEXTENDLANESTRUCT_H
#define DPC_IMPL_TYPE_ADJACENTEXTENDLANESTRUCT_H

#include <cfloat>
#include <cmath>
#include "impl_type_uint8.h"
#include "impl_type_float.h"

namespace dpc {
struct AdjacentExtendLaneStruct {
    ::UInt8 adjacent_extendlane_id{ 0U };
    ::Float adjacent_extendlane_offset{ 0.0F };
    ::Float adjacent_extendlane_endoffset{ 0.0F };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(adjacent_extendlane_id);
        fun(adjacent_extendlane_offset);
        fun(adjacent_extendlane_endoffset);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(adjacent_extendlane_id);
        fun(adjacent_extendlane_offset);
        fun(adjacent_extendlane_endoffset);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("adjacent_extendlane_id", adjacent_extendlane_id);
        fun("adjacent_extendlane_offset", adjacent_extendlane_offset);
        fun("adjacent_extendlane_endoffset", adjacent_extendlane_endoffset);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("adjacent_extendlane_id", adjacent_extendlane_id);
        fun("adjacent_extendlane_offset", adjacent_extendlane_offset);
        fun("adjacent_extendlane_endoffset", adjacent_extendlane_endoffset);
    }

    friend bool operator==(const ::dpc::AdjacentExtendLaneStruct& lhs, const ::dpc::AdjacentExtendLaneStruct& rhs) noexcept
    {
        return (lhs.adjacent_extendlane_id == rhs.adjacent_extendlane_id) && (fabs(static_cast<double>(lhs.adjacent_extendlane_offset - rhs.adjacent_extendlane_offset)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.adjacent_extendlane_endoffset - rhs.adjacent_extendlane_endoffset)) < DBL_EPSILON);
    }
};
} // namespace dpc


#endif // DPC_IMPL_TYPE_ADJACENTEXTENDLANESTRUCT_H
